Index: /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntExpressionGrammar.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntExpressionGrammar.cs	(revision 3338)
@@ -33,5 +33,5 @@
 
     public ArtificialAntExpressionGrammar()
-      : base(0, 3, 0, 3) {
+      : base() {
       Initialize();
     }
@@ -45,40 +45,32 @@
       var right = new Right();
       var defun = new Defun();
-      var invoke = new InvokeFunction();
       var allSymbols = new List<Symbol>() { ifFoodAhead, prog2, prog3, move, left, right };
       var nonTerminalSymbols = new List<Symbol>() { ifFoodAhead, prog2, prog3 };
-      SetMinSubTreeCount(ifFoodAhead, 2);
-      SetMaxSubTreeCount(ifFoodAhead, 2);
-      SetMinSubTreeCount(prog2, 2);
-      SetMaxSubTreeCount(prog2, 2);
-      SetMinSubTreeCount(prog3, 3);
-      SetMaxSubTreeCount(prog3, 3);
-      SetMinSubTreeCount(move, 0);
-      SetMaxSubTreeCount(move, 0);
-      SetMinSubTreeCount(left, 0);
-      SetMaxSubTreeCount(left, 0);
-      SetMinSubTreeCount(right, 0);
-      SetMaxSubTreeCount(right, 0);
-      foreach (var sym in allSymbols) {
-        AddAllowedSymbols(StartSymbol, 0, sym);
-        AddAllowedSymbols(defun, 0, sym);
 
-        for (int i = 0; i < GetMaxSubTreeCount(invoke); i++) {
-          AddAllowedSymbols(invoke, i, sym);
-        }
-      }
-      foreach (var sym in nonTerminalSymbols) {
-        for (int argIndex = 0; argIndex < GetMaxSubTreeCount(sym); argIndex++) {
-          AddAllowedSymbols(sym, argIndex, invoke);
-        }
-      }
-      foreach (var nonTerminal in nonTerminalSymbols) {
-        foreach (var child in allSymbols) {
-          for (int argIndex = 0; argIndex < GetMaxSubTreeCount(nonTerminal); argIndex++) {
-            AddAllowedSymbols(nonTerminal, argIndex, child);
+      allSymbols.ForEach(s => AddSymbol(s));
+      SetMinSubtreeCount(ifFoodAhead, 2);
+      SetMaxSubtreeCount(ifFoodAhead, 2);
+      SetMinSubtreeCount(prog2, 2);
+      SetMaxSubtreeCount(prog2, 2);
+      SetMinSubtreeCount(prog3, 3);
+      SetMaxSubtreeCount(prog3, 3);
+      SetMinSubtreeCount(move, 0);
+      SetMaxSubtreeCount(move, 0);
+      SetMinSubtreeCount(left, 0);
+      SetMaxSubtreeCount(left, 0);
+      SetMinSubtreeCount(right, 0);
+      SetMaxSubtreeCount(right, 0);
+
+      // each symbols is allowed as child of the start symbol
+      allSymbols.ForEach(s => SetAllowedChild(StartSymbol, s, 0));
+
+      // each symbol is allowed as child of all other symbols (except for terminals that have MaxSubtreeCount == 0
+      foreach (var parent in allSymbols) {
+        for (int argIndex = 0; argIndex < GetMaxSubtreeCount(parent); argIndex++) {
+          foreach (var child in allSymbols) {
+            SetAllowedChild(parent, child, argIndex);
           }
         }
       }
-
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Problems.ArtificialAnt/3.3/ArtificialAntProblem.cs	(revision 3338)
@@ -151,4 +151,12 @@
       set { MaxExpressionDepthParameter.Value = value; }
     }
+    public IntValue MaxFunctionDefinitions {
+      get { return MaxFunctionDefinitionsParameter.Value; }
+      set { MaxFunctionDefinitionsParameter.Value = value; }
+    }
+    public IntValue MaxFunctionArguments {
+      get { return MaxFunctionArgumentsParameter.Value; }
+      set { MaxFunctionArgumentsParameter.Value = value; }
+    }
     public SymbolicExpressionTreeCreator SolutionCreator {
       get { return SolutionCreatorParameter.Value; }
@@ -168,6 +176,6 @@
       get { return EvaluatorParameter.Value; }
     }
-    public ISymbolicExpressionGrammar ArtificialAntExpressionGrammar {
-      get { return ArtificialAntExpressionGrammarParameter.Value; }
+    public GlobalSymbolicExpressionGrammar ArtificialAntExpressionGrammar {
+      get { return (GlobalSymbolicExpressionGrammar)ArtificialAntExpressionGrammarParameter.Value; }
     }
     public ISingleObjectiveSolutionsVisualizer Visualizer {
@@ -191,16 +199,16 @@
       SymbolicExpressionTreeCreator creator = new ProbabilisticTreeCreator();
       Evaluator evaluator = new Evaluator();
-      ArtificialAntExpressionGrammar grammar = new ArtificialAntExpressionGrammar();
       BestAntTrailVisualizer visualizer = new BestAntTrailVisualizer();
       BoolMatrix world = new BoolMatrix(santaFeAntTrail);
+      ISymbolicExpressionGrammar grammar = new GlobalSymbolicExpressionGrammar(new ArtificialAntExpressionGrammar());
       Parameters.Add(new ValueParameter<BoolValue>("Maximization", "Set to true as the Artificial Ant Problem is a maximization problem.", new BoolValue(true)));
       Parameters.Add(new ValueParameter<SymbolicExpressionTreeCreator>("SolutionCreator", "The operator which should be used to create new artificial ant solutions.", creator));
       Parameters.Add(new ValueParameter<Evaluator>("Evaluator", "The operator which should be used to evaluate artificial ant solutions.", evaluator));
       Parameters.Add(new ValueParameter<DoubleValue>("BestKnownQuality", "The quality of the best known solution of this artificial ant instance.", new DoubleValue(89)));
-      Parameters.Add(new ValueParameter<ISymbolicExpressionGrammar>("ArtificialAntExpressionGrammar", "The grammar that should be used for artificial ant expressions.", grammar));
       Parameters.Add(new ValueParameter<IntValue>("MaxExpressionLength", "Maximal length of the expression to control the artificial ant.", new IntValue(100)));
       Parameters.Add(new ValueParameter<IntValue>("MaxExpressionDepth", "Maximal depth of the expression to control the artificial ant.", new IntValue(10)));
       Parameters.Add(new ValueParameter<IntValue>("MaxFunctionDefinitions", "Maximal number of automatically defined functions in the expression to control the artificial ant.", new IntValue(3)));
       Parameters.Add(new ValueParameter<IntValue>("MaxFunctionArguments", "Maximal number of arguments of automatically defined functions in the expression to control the artificial ant.", new IntValue(3)));
+      Parameters.Add(new ValueParameter<ISymbolicExpressionGrammar>("ArtificialAntExpressionGrammar", "The grammar that should be used for artificial ant expressions.", grammar));
       Parameters.Add(new ValueParameter<BoolMatrix>("World", "The world for the artificial ant with scattered food items.", world));
       Parameters.Add(new ValueParameter<IntValue>("MaxTimeSteps", "The number of time steps the artificial ant has available to collect all food items.", new IntValue(600)));
@@ -292,4 +300,16 @@
       Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
       VisualizerParameter.ValueChanged += new EventHandler(VisualizerParameter_ValueChanged);
+      MaxFunctionArgumentsParameter.ValueChanged += new EventHandler(MaxFunctionArgumentsParameter_ValueChanged);
+      MaxFunctionArguments.ValueChanged += new EventHandler(MaxFunctionArgumentsParameter_ValueChanged);
+      MaxFunctionDefinitionsParameter.ValueChanged += new EventHandler(MaxFunctionDefinitionsParameter_ValueChanged);
+      MaxFunctionDefinitions.ValueChanged += new EventHandler(MaxFunctionDefinitionsParameter_ValueChanged);
+    }
+
+    void MaxFunctionDefinitionsParameter_ValueChanged(object sender, EventArgs e) {
+      ArtificialAntExpressionGrammar.MaxFunctionDefinitions = MaxFunctionDefinitions.Value;
+    }
+
+    void MaxFunctionArgumentsParameter_ValueChanged(object sender, EventArgs e) {
+      ArtificialAntExpressionGrammar.MaxFunctionArguments = MaxFunctionArguments.Value;
     }
 
@@ -348,4 +368,8 @@
         op.MaxFunctionArgumentsParameter.ActualName = MaxFunctionArgumentsParameter.Name;
       }
+      foreach (SymbolicExpressionTreeCreator op in Operators.OfType<SymbolicExpressionTreeCreator>()) {
+        op.MaxFunctionArgumentsParameter.ActualName = MaxFunctionArgumentsParameter.Name;
+        op.MaxFunctionDefinitionsParameter.ActualName = MaxFunctionDefinitionsParameter.Name;
+      }
     }
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/ArithmeticExpressionGrammar.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/ArithmeticExpressionGrammar.cs	(revision 3337)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Regression/3.3/Symbolic/ArithmeticExpressionGrammar.cs	(revision 3338)
@@ -48,5 +48,5 @@
 
     public ArithmeticExpressionGrammar()
-      : base(0, 0, 0, 0) {
+      : base() {
       Initialize();
     }
@@ -62,20 +62,27 @@
       var allSymbols = new List<Symbol>() { add, sub, mul, div, constant, variableSymbol };
       var functionSymbols = new List<Symbol>() { add, sub, mul, div };
-      allSymbols.ForEach(s => AddAllowedSymbols(StartSymbol, 0, s));
+      foreach (var symb in allSymbols)
+        AddSymbol(symb);
 
+      foreach (var funSymb in functionSymbols) {
+        SetMinSubtreeCount(funSymb, 1);
+        SetMaxSubtreeCount(funSymb, 3);
+      }
+      SetMinSubtreeCount(constant, 0);
+      SetMaxSubtreeCount(constant, 0);
+      SetMinSubtreeCount(variableSymbol, 0);
+      SetMaxSubtreeCount(variableSymbol, 0);
 
-      SetMinSubTreeCount(constant, 0);
-      SetMaxSubTreeCount(constant, 0);
-      SetMinSubTreeCount(variableSymbol, 0);
-      SetMaxSubTreeCount(variableSymbol, 0);
-      int maxSubTrees = 3;
-      foreach (var functionSymbol in functionSymbols) {
-        SetMinSubTreeCount(functionSymbol, 1);
-        SetMaxSubTreeCount(functionSymbol, maxSubTrees);
-        foreach (var childSymbol in allSymbols) {
-          for (int argumentIndex = 0; argumentIndex < maxSubTrees; argumentIndex++) {
-            AddAllowedSymbols(functionSymbol, argumentIndex, childSymbol);
+      // allow each symbol as child of the start symbol
+      foreach (var symb in allSymbols) {
+        SetAllowedChild(StartSymbol, symb, 0);
+      }
+
+      // allow each symbol as child of every other symbol (except for terminals that have maxSubtreeCount == 0)
+      foreach (var parent in allSymbols) {
+        for (int i = 0; i < GetMaxSubtreeCount(parent); i++)
+          foreach (var child in allSymbols) {
+            SetAllowedChild(parent, child, i);
           }
-        }
       }
     }
